# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime
import driverng

parser_class = "e4l_facturation_xml"

worklist = driverng.Worklist(
    context="result",
    filename="PEL-FAC_YYYYMMDDHHMMSS.xml",
    samples=[
        {
            "billings": [
                {
                    "code_executant": "ASD789",
                    "nom_executant": "Labo ABC",
                    "specification_name": "DEDALUS_IVD_LIS_PEL",
                    "specification_version": "1.0",
                    "total_amount": "100",
                    "currency": "€",
                    "fee_note": "fichier note d'honoraire pdf encodé en base64",
                    "receipt": "fichier quittance de paiement pdf encodé en base64",
                }
            ],
            "sample_id": "123456",
            "request_id": "78910",
            "type": "patient",
            "last_name": "NYME",
            "first_name": "ANO",
            "title": "Mme",
            "further_names": ["ANO", "Pauline", "Anne"],
            "birthdate": datetime.datetime(2011, 5, 13, 12, 15),
            "birthplace_code": "29064",
            "sex": "F",
            "patient_id": "036666666",
            "ins_number": "276037510669380",
            "oid": "1.2.250.1.213.1.4.8",
            "identity_status": "Qualifiée",
            "priority": "R",
        }
    ],
    sender_id="SENDER_ID",
    sender_name="SENDER_NAME",
)


def test_order(self):
    message = self.order(worklist=worklist)
    expected = """
    <?xml version="1.0" encoding="UTF-8"?>
    <financial>
        <fileinfo>
            <filename>PEL-FAC_YYYYMMDDHHMMSS.xml</filename>
            <datetime>20130715141912</datetime>
            <specification>
                <specificationName>DEDALUS_IVD_LIS_PEL</specificationName>
                <specificationVersion>1.0</specificationVersion>
            </specification>
        </fileinfo>
        <organization>
            <idSite>SENDER_ID</idSite>
            <nameSite>SENDER_NAME</nameSite>
            <idLab>ASD789</idLab>
            <nameLab>Labo ABC</nameLab>
        </organization>
        <patient>
            <localId>036666666</localId>
            <INS>
                <value>276037510669380</value>
                <OID>1.2.250.1.213.1.4.8</OID>
                <familyName>NYME</familyName>
                <firstName>ANO</firstName>
                <firstNames>ANO Pauline Anne</firstNames>
                <sex>F</sex>
                <birthDay>20110513</birthDay>
                <birthPlace>29064</birthPlace>
            </INS>
        </patient>
        <request>
            <id>78910</id>
            <totalAmount>100</totalAmount>
            <unpaidAmount>0</unpaidAmount>
            <currency>€</currency>
            <attachedFiles>
                <feeNote mime="application/pdf">fichier note d'honoraire pdf encodé en base64</feeNote>
                <receipt mime="application/pdf">fichier quittance de paiement pdf encodé en base64</receipt>
            </attachedFiles>
        </request>
    </financial>
    """
    assert message == expected
