# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "prisca"


def test_encode_order(self):
    message = self.order()
    expected = """
    H|^~\\&|||CLARISYS||ORM|||SIEMENS|||A2.2|20130715141912
    P|1|036666666|L036666666||NYME^ANO|NJF|20110513|F
    OBR|1|123456^12345620130513||A~B|||20130513114242||||N||Information clinique|20130513114242|Serum|^PRESCRIBER^^^SER
    OBX|1|ST|REF1||PRESCRIBER||||||F
    OBX|2|NM|A||42||||||F||20110506121400
    L|1|N"""
    assert message == expected


def test_decode_result(self):
    worklist = self.decode(
        """
    H|^~\\&|||PRISCA||ORU|||CLARISYS||P|A2.2|20140909165900|
    P|1|0090901333607|||BEN ZINA^Ikram||19920805|
    OBR|1|00140130673^14013067320140909||CR21~BR21~PAPP~FBCO~FB~PACM~NTCO~GWSM~GADS|R||20140909110430||||N||   |20140909110430||^HAMAMI^^^D4^|
    OBX|1|ST|AFPC^||N/A||||||F||||
    OBX|2|NM|FBCO^FBCorrMoM||0.97||||||F||||
    OBX|2|DT|SDAT^SampleDate||20150120||||||F||||
    L|1"""
    )
    date = datetime.datetime(2014, 9, 9, 16, 59)
    expected = {
        "context": "result",
        "samples": [
            {
                "type": "patient",
                "sample_id": "00140130673",
                "results": [
                    {"code": "AFPC", "value": "N/A", "date": date},
                    {"code": "FBCO", "value": "0.97", "date": date},
                    {"code": "SDAT", "value": "20150120000000", "date": date},
                ],
            }
        ],
    }
    assert worklist == expected
