# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

from driverng.tests import BaseTest

RESULT_MESSAGE = """MSH|^~\\&|SeegeneViewer|Seegene|||20180906173520.19+0100||ORU^R01^ORU_R01|23401|P|2.5
OBR|1||297972^A01|Allplex Respiratory Panel 1 (96 plate)^-
NTE|1|P|FAM~RSV A~~-~Ct.~N/A
NTE|2|P|FAM~Flu A~~-~Ct.~N/A"""


class TestProtocolStarlet(BaseTest):
    PROTOCOL_CLASS = "starlet"

    def test_ack(self):
        message = self.P.get_ack_message(
            RESULT_MESSAGE.encode(),
            date=datetime.datetime(2014, 1, 1, 12, 42, 24),
            control_id=b"CONTROLID",
        )
        expected = b"MSH|^~\\&|||SeegeneViewer|Seegene|20140101124224||ORU^R01|CONTROLID|P|2.5\rMSA|AA|23401|A01|\r"
        assert message == expected
