# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "sca_datashare"


def test_encode_order(self):
    message = self.order()
    expected = """
    MSH|^~\\&|MCA|MCA|SCA|SCA|20130715141912||ORM^001||P|2.4
    PID|1||036666666||NYME^ANO||20110513||||45 rue lambda\\S\\lala, 31000 Toulouse||||FRA
    PV1|1|||||||PRESCRIBER^^Prescriber
    ORC|NW||123456
    OBR|1|123456||LOC^LOCATION|||20130603110342|||||||20130513114242
    OBX|1|SN|A||^42|mV
    OBX|2|DT|B||^201302131516
    """
    assert message == expected


def test_decode_result(self):
    date = datetime.datetime(2016, 1, 1, 0, 0)
    worklist = self.decode(
        """
    MSH|^~\\&|SCA|SCA|LIS|LIS|201601010000||ORU^R01||P|2.4|||||||
    PID|1||001||Surname^Name||||||||||||||
    PV1||||||||id^ Surname^Name |
    OBR|1|1001|1001||||20160101|||||||||||||||20160101||||||||||
    OBX|1|TX|SCADOCTOR||^87||||||F
    OBX|1|SN|SCAABS||^3|days|3_100||||
    OBX|2|SN|SCACOLLMET||^at laboratory||||||
    OBX|3|SN|SCACOLLDIF||^Incomplete||||||
    OBX|4|SN|SCAVIS||^Abnormal||||||F
    OBX|5|SN|SVOL||^2.80|mL|||||F
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "results": [
                    {"code": "SCADOCTOR", "value": "87", "unit": "", "date": date},
                    {"code": "SCAABS", "value": "3", "unit": "days", "date": date},
                    {
                        "code": "SCACOLLMET",
                        "value": "at laboratory",
                        "unit": "",
                        "date": date,
                    },
                    {
                        "code": "SCACOLLDIF",
                        "value": "Incomplete",
                        "unit": "",
                        "date": date,
                    },
                    {"code": "SCAVIS", "value": "Abnormal", "unit": "", "date": date},
                    {"code": "SVOL", "value": "2.80", "unit": "mL", "date": date},
                ],
                "sample_id": "1001",
                "type": "patient",
            }
        ],
    }
    assert worklist == expected
