# -*- coding: utf8 -*-

from __future__ import unicode_literals

import datetime

from driverng.tests import BaseTest

MESSAGE = """MSH|^~\\&|PCC^GEM 4000;07121016|KH-01|LIS|KH-01|20090924120513||ORU^R01|117725235|P|2.4|||AL|NE||8859/1
        PID|1||2222||Musterfrau^Eva||19550210|F||||||||||||||||||
        PV1|1||32||||Doctor||||||||||||082222|||||||||||||||||||||||||||||||
        ORC|1||||CM||||||||
        OBR|1|||Elektrolyte|||20080225142233|20080225142233|||N|||18991230000000|BLDA||||||||||||^^^20080225142233^^R|||||||
        NTE|1|D|Repeated measurement|
        OBX|1|NM|Ca++^Ca++||1.14|mmol/L|1.17-1.37|N|||F|||20080225142233||||07121016|20080225142233
"""


class TestProtocolHl7Poc(BaseTest):
    PROTOCOL_CLASS = "hl7poc"

    def test_ack(self):
        message = self.P.get_ack_message(
            MESSAGE.encode(),
            date=datetime.datetime(2014, 1, 1, 12, 42, 24),
            control_id=b"CONTROLID",
        )
        expected = b"""MSH|^~\\&|LIS||PCC^GEM 4000;07121016||20140101124224||ACK|CONTROLID|P|2.4|||AL|NE||8859/1|D\rMSA|AA|117725235|||F\r"""
        assert message == expected
